var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { createPortal } from 'react-dom';

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Alert = (_temp = _class = function (_Component) {
  _inherits(Alert, _Component);

  function Alert(props) {
    _classCallCheck(this, Alert);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidMount = function () {};

    return _this;
  }

  Alert.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        portal = _props.portal,
        show = _props.show,
        _props$maskAttribute = _props.maskAttribute,
        maskAttribute = _props$maskAttribute === undefined ? {} : _props$maskAttribute,
        caption = _props.caption,
        _props$captionAttribu = _props.captionAttribute,
        captionAttribute = _props$captionAttribu === undefined ? {} : _props$captionAttribu,
        icon = _props.icon,
        _props$contentAttribu = _props.contentAttribute,
        contentAttribute = _props$contentAttribu === undefined ? {} : _props$contentAttribu,
        submitCaption = _props.submitCaption,
        _props$submitAttribut = _props.submitAttribute,
        submitAttribute = _props$submitAttribut === undefined ? {} : _props$submitAttribut,
        cancelCaption = _props.cancelCaption,
        _props$cancelAttribut = _props.cancelAttribute,
        cancelAttribute = _props$cancelAttribut === undefined ? {} : _props$cancelAttribut,
        children = _props.children,
        others = _objectWithoutProperties(_props, ['portal', 'show', 'maskAttribute', 'caption', 'captionAttribute', 'icon', 'contentAttribute', 'submitCaption', 'submitAttribute', 'cancelCaption', 'cancelAttribute', 'children']);

    return createPortal(React.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, maskAttribute, { className: 'mask alert-mask' + (maskAttribute.className ? ' ' + maskAttribute.className : '') + (show ? ' active' : '') }),
      React.createElement(
        'div',
        _extends({ 'data-animation': 'zoom' }, others, { className: 'alert' + (others.className ? ' ' + others.className : '') + (show ? ' active' : '') }),
        caption && React.createElement(
          'h1',
          captionAttribute,
          caption
        ),
        React.createElement(
          'div',
          _extends({}, contentAttribute, { className: 'alert-content' + (contentAttribute.className ? ' ' + contentAttribute.className : '') }),
          icon,
          children
        ),
        React.createElement(
          'div',
          { className: 'alert-handler' },
          cancelAttribute.onClick && React.createElement(
            'a',
            _extends({}, cancelAttribute, { className: 'alert-cancel button lg' + (cancelAttribute.className ? ' ' + cancelAttribute.className : '') }),
            cancelCaption
          ),
          submitAttribute.onClick && React.createElement(
            'a',
            _extends({}, submitAttribute, { className: 'alert-submit button lg' + (submitAttribute.className ? ' ' + submitAttribute.className : '') }),
            submitCaption
          )
        )
      )
    ), this.props.portal || document.getElementById('root') || document.body);
  };

  return Alert;
}(Component), _class.defaultProps = {
  submitCaption: window._seeds_lang['ok'] || '确定',
  cancelCaption: window._seeds_lang['cancel'] || '取消'
}, _temp);
export { Alert as default };
Alert.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: PropTypes.object,
  show: PropTypes.bool,

  maskAttribute: PropTypes.object,

  caption: PropTypes.node,
  captionAttribute: PropTypes.object,

  icon: PropTypes.node,

  contentAttribute: PropTypes.object,

  submitCaption: PropTypes.node,
  submitAttribute: PropTypes.object,

  cancelCaption: PropTypes.node,
  cancelAttribute: PropTypes.object,

  children: PropTypes.node
} : {};