var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp, _initialiseProps;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { createPortal } from 'react-dom';
import Carrousel from './../Carrousel';
import InputPre from './../InputPre';
import Button from './../Button';
import Instance from './instance.js';
import data from './instance.data.js';

if (!window._seeds_lang) window._seeds_lang = {}; // 国际化数据

var Emoji = (_temp = _class = function (_Component) {
  _inherits(Emoji, _Component);

  function Emoji(props) {
    _classCallCheck(this, Emoji);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _initialiseProps.call(_this);

    return _this;
  }
  // 表情

  // 过滤已经回调的属性


  Emoji.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        portal = _props.portal,
        show = _props.show,
        data = _props.data,
        autoFocus = _props.autoFocus,
        value = _props.value,
        placeholder = _props.placeholder,
        _props$maskAttribute = _props.maskAttribute,
        maskAttribute = _props$maskAttribute === undefined ? {} : _props$maskAttribute,
        _props$submitProps = _props.submitProps,
        submitProps = _props$submitProps === undefined ? {} : _props$submitProps,
        _props$inputProps = _props.inputProps,
        inputProps = _props$inputProps === undefined ? {} : _props$inputProps,
        _props$carrouselProps = _props.carrouselProps,
        carrouselProps = _props$carrouselProps === undefined ? {} : _props$carrouselProps,
        _props$liconAttribute = _props.liconAttribute,
        liconAttribute = _props$liconAttribute === undefined ? {} : _props$liconAttribute,
        licon = _props.licon,
        onChange = _props.onChange,
        others = _objectWithoutProperties(_props, ['portal', 'show', 'data', 'autoFocus', 'value', 'placeholder', 'maskAttribute', 'submitProps', 'inputProps', 'carrouselProps', 'liconAttribute', 'licon', 'onChange']);

    // 剔除掉onClick事件, 因为在instance时已经回调了


    maskAttribute = this.filterProps(maskAttribute);
    submitProps = this.filterProps(submitProps);

    return createPortal(React.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, maskAttribute, { className: 'mask emoji-mask' + (show ? ' active' : '') + (maskAttribute.className ? ' ' + maskAttribute.className : '') }),
      React.createElement(
        'div',
        _extends({}, others, { className: 'emoji active' + (others.className ? ' ' + others.className : '') }),
        licon,
        liconAttribute && React.createElement('i', _extends({}, liconAttribute, { className: 'icon' + (liconAttribute.className ? ' ' + liconAttribute.className : '') })),
        React.createElement(
          'div',
          { className: 'emoji-edit' },
          React.createElement(InputPre, _extends({
            ref: '$ComponentInputPre',
            className: 'emoji-edit-input',
            inputAttribute: { style: { padding: '0' } },
            value: value,
            onChange: onChange,
            placeholder: placeholder
          }, inputProps)),
          React.createElement('i', { ref: function ref(el) {
              _this2.$icon = el;
            }, className: 'icon emoji-edit-icon' }),
          React.createElement(
            Button,
            _extends({ ref: '$ComponentSubmit' }, submitProps, { className: 'emoji-edit-submit' + (submitProps.className ? ' ' + submitProps.className : ''), disabled: !value }),
            submitProps.caption || window._seeds_lang['submit'] || '提交'
          )
        ),
        React.createElement(
          Carrousel,
          _extends({ ref: '$ComponentCarrousel' }, carrouselProps, { pagination: true, className: 'carrousel-container emoji-carrousel' + (carrouselProps.className ? ' ' + carrouselProps.className : ''), style: { display: 'none' } }),
          this.getFaceDOM()
        )
      )
    ), portal || document.getElementById('root') || document.body);
  };

  return Emoji;
}(Component), _class.defaultProps = {
  autoFocus: false,
  data: data,
  placeholder: window._seeds_lang['say_something'] || '说点什么吧...'
}, _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentDidUpdate = function (prevProps) {
    // 自动获取焦点
    if (_this3.props.autoFocus && prevProps.show !== _this3.props.show && _this3.props.show === true && _this3.$input) {
      _this3.$input.focus();
    }
  };

  this.componentDidMount = function () {
    // 输入框
    _this3.$inputEl = _this3.refs.$ComponentInputPre.$el;
    _this3.$input = _this3.refs.$ComponentInputPre.$input;
    // 提交按钮
    _this3.$submit = _this3.refs.$ComponentSubmit.$el;
    // 滑动表情框
    _this3.$carrousel = _this3.refs.$ComponentCarrousel.$el;
    if (_this3.props.autoFocus && _this3.$input) _this3.$input.focus();
    if (_this3.instance) return;
    var _props2 = _this3.props,
        _props2$maskAttribute = _props2.maskAttribute,
        maskAttribute = _props2$maskAttribute === undefined ? {} : _props2$maskAttribute,
        _props2$submitProps = _props2.submitProps,
        submitProps = _props2$submitProps === undefined ? {} : _props2$submitProps;

    _this3.instance = new Instance({
      data: _this3.props.data,

      mask: _this3.$el,
      isClickMaskHide: false,
      onClickMask: maskAttribute.onClick || null,

      onClickSubmit: submitProps.onClick || null,

      onChange: _this3.props.onChange
    });
  };

  this.getFaceDOM = function () {
    var data = _this3.props.data;
    // icons分页变量

    var icons = [];
    var page = 0;
    var index = 0;
    var count = 23;
    // icons分页
    for (var name in data) {
      if (index !== 0 && index % count === 0) {
        page++;
      }
      if (!icons[page]) icons[page] = [];
      icons[page].push({ key: name, value: data[name] });
      index++;
    }
    // 生成DOM
    return icons.map(function (icon, i) {
      return React.createElement(
        'div',
        { key: 'page' + i, className: 'emoji-carrousel-slide' },
        icon.map(function (item, index) {
          return React.createElement(
            'a',
            { key: 'face' + index, className: 'emoji-face', 'data-emoji': item.value, title: item.key },
            '\xA0'
          );
        }),
        React.createElement(
          'a',
          { className: 'emoji-face-delete' },
          '\xA0'
        )
      );
    });
  };

  this.filterProps = function (props) {
    if (!props) return props;
    var propsed = {};
    for (var n in props) {
      if (n !== 'onClick') {
        propsed[n] = props[n];
      }
    }
    return propsed;
  };
}, _temp);
export { Emoji as default };
Emoji.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: PropTypes.object,
  show: PropTypes.bool, // ios内核必须隐藏, 不能移除dom, 弹出时才不会有bug, 所以必须用show
  data: PropTypes.object,

  autoFocus: PropTypes.bool,
  value: PropTypes.string,
  placeholder: PropTypes.string,

  maskAttribute: PropTypes.object,
  submitProps: PropTypes.object,
  inputProps: PropTypes.object,
  carrouselProps: PropTypes.object,
  liconAttribute: PropTypes.object,
  licon: PropTypes.node,

  onChange: PropTypes.func
} : {};