var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Instance from './instance.js';

var IndexBar = (_temp = _class = function (_Component) {
  _inherits(IndexBar, _Component);

  function IndexBar(props) {
    _classCallCheck(this, IndexBar);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      if (_this.props.overflowContainer !== prevProps.overflowContainer) {
        _this.instance.setOverflowContainer(_this.props.overflowContainer);
      }
    };

    return _this;
  }

  IndexBar.prototype.componentDidMount = function componentDidMount() {
    var overflowContainer = this.$el.parentNode;
    var instance = new Instance({
      overflowContainer: this.props.overflowContainer || overflowContainer,
      parent: this.props.parent || document.body
    });
    this.instance = instance;
  };

  IndexBar.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        overflowContainer = _props.overflowContainer,
        parent = _props.parent,
        indexs = _props.indexs,
        others = _objectWithoutProperties(_props, ['overflowContainer', 'parent', 'indexs']);

    return React.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, others, { className: 'indexbar' + (others.className ? ' ' + others.className : '') }),
      indexs.map(function (index, i) {
        return React.createElement(
          'a',
          { key: 'btn' + i },
          index
        );
      })
    );
  };

  return IndexBar;
}(Component), _class.defaultProps = {
  indexs: ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'G', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z']
}, _temp);
export { IndexBar as default };
IndexBar.propTypes = process.env.NODE_ENV !== "production" ? {
  overflowContainer: PropTypes.any, // 滚动区域
  parent: PropTypes.any, // DOM注入容器
  indexs: PropTypes.array
} : {};