var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Instance from './instance.js';
import BScroll from 'better-scroll';

var PDFView = (_temp = _class = function (_Component) {
  _inherits(PDFView, _Component);

  function PDFView(props) {
    _classCallCheck(this, PDFView);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.instance = function () {
      var _this$props = _this.props,
          pictures = _this$props.pictures,
          src = _this$props.src,
          cMapUrl = _this$props.cMapUrl,
          _this$props$params = _this$props.params,
          params = _this$props$params === undefined ? {} : _this$props$params;

      if (!src && !pictures) return;
      _this.instance = new Instance(_this.$el, _extends({
        pictures: pictures,
        src: src,
        cMapUrl: cMapUrl
      }, params, {
        onLoad: function onLoad(s) {
          if (params.onLoad) params.onLoad(s);
          if (_this.bscroll) {
            console.log('加载完成, bscroll刷新');
            _this.bscroll.finishPullUp();
            _this.bscroll.refresh();
            return;
          }
          _this.bscroll = new BScroll('.pdf-container', {
            scrollX: true,
            zoom: {
              start: 1,
              min: 1,
              max: 4
            },
            probeType: 2,
            pullUpLoad: {
              threshold: 10
            }
          });
          // 上拉到底部刷新
          _this.bscroll.on('pullingUp', function () {
            _this.instance.addPages();
          });
        }
      }));
    };

    return _this;
  }

  PDFView.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _props = this.props,
        pictures = _props.pictures,
        src = _props.src,
        cMapUrl = _props.cMapUrl,
        _props$params = _props.params,
        params = _props$params === undefined ? {} : _props$params;

    if (src && src !== prevProps.src || pictures && pictures !== prevProps.pictures) {
      if (!this.instance) {
        this.instance();
      } else {
        this.instance.update(_extends({
          pictures: pictures,
          src: src,
          cMapUrl: cMapUrl
        }, params));
      }
    }
  };

  PDFView.prototype.componentDidMount = function componentDidMount() {
    this.instance();
  };

  PDFView.prototype.render = function render() {
    var _this2 = this;

    var _props2 = this.props,
        pictures = _props2.pictures,
        src = _props2.src,
        cMapUrl = _props2.cMapUrl,
        _props2$params = _props2.params,
        params = _props2$params === undefined ? {} : _props2$params,
        others = _objectWithoutProperties(_props2, ['pictures', 'src', 'cMapUrl', 'params']);

    if (!src && !pictures) {
      return null;
    }
    return React.createElement(
      'div',
      _extends({ className: 'pdf-container' }, others, { ref: function ref(el) {
          _this2.$el = el;
        } }),
      React.createElement('div', { className: 'pdf-wrapper' })
    );
  };

  return PDFView;
}(Component), _class.defaultProps = {}, _temp);
export { PDFView as default };
PDFView.propTypes = process.env.NODE_ENV !== "production" ? {
  pictures: PropTypes.array, // 图片地址
  src: PropTypes.string, // pdf地址或data:application/pdf;base64,开头的base64pdf流文件
  cMapUrl: PropTypes.string, // 设置cMapUrl, 解决中文不显示的问题
  params: PropTypes.object // 设置实例化参数
  // params: {
  //   rows: 5, // 分页, 一页的条数
  //   errorHTML: '文件加载失败', // 加载错误时显示的信息
  //   loadHTML: '加载中', // 加载时显示的信息
  //   nodataHTML: '暂无数据', // 暂无数据
  //   pdfLib: '//res.waiqin365.com/d/seedsui/pdfview/pdf.js', // pdf.js库
  //   pdfWorkLib: '//res.waiqin365.com/d/seedsui/pdfview/pdf.worker.js' // pdf.work.js库
  // }
} : {};